mode(-1);
// specific part
libname='totolib' // name of scilab function library [CUSTOM]

// generic part  
// get the absolute path 
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1 
  l=strindex(nams(k),'builder.sce');
  if l<>[] then
    DIR=part(nams(k),1:l($)-1);
    break
  end
end


if ~MSDOS then // Unix Linux
  if part(DIR,1)<>'/' then DIR=getcwd()+'/'+DIR,end
  MACROS=DIR+'macros/' // Path of the macros directory
  SRC=DIR+'src/' // Path of the source (Fortran) directory
  // Create Makefile
  u=file('open',SRC+'Makefile','unknown')
  write(u,['SCIDIR = '+SCI
      'TOTODIR = '+DIR
      'LIBRARY = toto.a ' //object file library  [CUSTOM]
      'OBJSF = toto.o scitoto.o'//Fortran objects (do not inculde interface) [CUSTOM]
      'OBJSC = '//C objects (do not inculde interface) [CUSTOM]
      'include '+SCI+'/Makefile.incl'
      'CFLAGS = $(CC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines'
      'FFLAGS = $(FC_OPTIONS) $(CC_PICFLAGS) -I'+SCI+'/routines'
      'include '+SCI+'/routines/Make.lib'
      'all :: intertoto.o'],'(a)') //interface object [CUSTOM]
  file('close',u)
  cmd_make='make'
else  // windows- Visual C++
  if part(DIR,2)<>':' then DIR=getcwd()+'\'+DIR,end
  MACROS=DIR+'macros\' // Path of the macros directory
  SRC=DIR+'src\' // Path of the source (Fortran) directory
  SCI=strsubst(SCI,'/','\') // path of Scilab
  
    //to avoid problems with pathnames including long names we make 
  // a local copy of  $SCI/Makefile.incl.mak
  mkf=read(SCI+'\Makefile.incl.mak',-1,1,'(a)')
  mkf=strsubst(mkf,'$(SCIDIR)/routines/f2c','""'+SCI+'\routines\f2c""')
  mkf=strsubst(mkf,'$(SCIDIR1)\bin\f2c.exe','""'+SCI+'\bin\f2c.exe""')
  mkf=strsubst(mkf,'$(SCIDIR)',SCI)
  mkf=strsubst(mkf,'$(SCIDIR1)',SCI)

  u=file('open','Makefile.incl.mak','unknown')
  write(u,mkf,'(a)')
  file('close',u)
  
  
  u=file('open',SRC+'Makefile','unknown')
  tab=code2str(-40)
  write(u,['SCIDIR1 = ""'+SCI+'""'
      'SCIDIR = ""'+SCI+'""'
      'DUMPEXTS = ""'+SCI+'\bin\dumpexts.exe""'
      'SCIIMPLIB = ""'+SCI+'\bin\LibScilab.lib""'
      'LIBRARY = toto.lib ' //object file library [CUSTOM]
      'OBJSF = intertoto.obj toto.obj scitoto.obj' //Fortran objects files [CUSTOM]
      'OBJSC = '//C objects files [CUSTOM]
      'include ..\Makefile.incl.mak'
      'CFLAGS = $(CC_OPTIONS) -DFORDLL -I""'+SCI+'\routines""'
      'FFLAGS = $(FC_OPTIONS) -DFORDLL -I""'+SCI+'\routines""'
      ' '
      'all :: intertoto.dll' //dynamic library [CUSTOM]
      ' '
      'intertoto.dll: $(OBJSC)'
        tab+'@$(DUMPEXTS) -o ""$*.def"" ""$*.dll"" $**'
        tab+'@$(LINKER) $(LINKER_FLAGS) $(OBJSC) $(OBJSF) $(SCIIMPLIB) $(XLIBSBIN)'+..
      ' $(TERMCAPLIB) /nologo /dll /out:""$*.dll"" /implib:""$*.ilib"" '+..
      '/def:""$*.def""'
      'distclean ::'
      tab+'@del *.obj';
      tab+'@del *.dll'
      tab+'@del *.ilib'
      tab+'@del *.def'],'(a)')
  file('close',u)
  cmd_make='nmake /f Makefile'
end
// compile Fortran and C sources in src
OLD=getcwd();chdir(SRC)
unix_s(cmd_make)
chdir(OLD);

//compile sci files if necessary and build lib file
genlib(libname,MACROS)

clear fd err nams DIR libname MACROS genlib SRC OLD cmd_make
