mode(-1);
libname='totolib' [CUSTOM]
libtitle='Computing complex stuff'; // title of the toolbox [CUSTOM]

mess=[' ';' ';libtitle+' loaded';
    'execute ""totodemos()"" for demonstrations'] // (if any) [CUSTOM]

// generic part  
// get the absolute path 
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1 
  l=strindex(nams(k),'loader.sce');
  if l<>[] then
    DIR=part(nams(k),1:l($)-1);
    break
  end
end

if ~MSDOS then //Unix
  if part(DIR,1)<>'/' then DIR=getcwd()+'/'+DIR,end
  MACROS=DIR+'macros/'
  // Add primitives
  addinter(DIR+'src/'+['intertoto.o','toto.a'],"entrypointoto","totoi")  //[CUSTOM]
else // Visual C++
  if part(DIR,2)<>':' then DIR=getcwd()+'\'+DIR,end
  DIR=strsubst(DIR,'/','\');
  MACROS=DIR+'macros\'
  // Add primitives
  addinter(DIR+'src\intertoto.dll',"entrypointoto","totoi") //[CUSTOM]
end
// load the library
execstr(libname+'=lib(""'+MACROS+'"")')
// add the help chapter
write(%io(2),mess)
%helps = [%helps; DIR+'man', libtitle]
chfact;

clear fd err nams DIR libname libtitle mess  //clean environment
